[BITS 32]
; setup the kernel page directory and tables for 4megs
; just below the kernel at the 2mB mark
PAGE_DIRECTORY	equ	0200000h	; The Page Directory
PAGE_TABLE		equ	0201000h	; The page tables start here
PAGE_COUNT		equ	1024		; map only 4 MB now

Init_Paging:
	cli
	
	mov esi,PageMsg
	call PrintPMode
	
	xor ecx,ecx
	xor edx,edx
@pg_loop1:
	cmp ecx,PAGE_COUNT; page the first 4Mb of memory
	je @pg_1
	mov eax,edx
	or eax,3		; set supervisor, read/write, present
	mov dword[PAGE_TABLE+ecx*4],eax

	add edx,4096
	inc ecx
	jmp @pg_loop1

@pg_1:
	mov eax,PAGE_TABLE	; setup
	or eax,3			; only the first directory entry
	mov [PAGE_DIRECTORY],eax;
	
	xor ecx,ecx
@pg_loop2:
	inc ecx
	mov dword[PAGE_DIRECTORY+ecx*4],02h	; 010 binary supervisor, not present
	cmp ecx,1024	; fill the rest of the page directory
	jl @pg_loop2

	xor eax,eax
	mov cr3,eax

	mov eax,PAGE_DIRECTORY
	mov cr3,eax

	mov eax,cr0
	or eax,80000000h
	mov cr0,eax
	
	mov esi,PageOk
	call PrintPMode	
	ret

; eax : Address of page to alloc
AllocPage:
	push ebp
	mov ebp,esp

	shr eax,12	; divide by 4096
	mov ebx,1
	shl ebx,eax
	shr eax,3	; divide by 8
	or [Mem_Bitmap+eax],ebx
	leave
	ret

Mem_Bitmap	times	(PAGE_COUNT*4)/8) db	0	; 512 bytes